#!/bin/bash

# Produces PDF file (using LaTeX) for only a specified module
# 
# module shold be specified without .tex extension
#
#
#Author: Tom Salmon

# Usage:
#	make-module.sh <module>

if [ $# -ne 1 ]
then
	echo "Usage: make-module.sh";
	exit;
fi

# check if file exists
if [ ! -f $1.tex ]
then
	echo "File: $1.tex does not exist";
	exit;
fi

#add LaTeX headers
sed -e '1i\
\\documentclass[a4paper]{article}\
\\usepackage{geometry}\
\\geometry{left=20mm}\
\\geometry{right=12mm}\
\\geometry{top=12mm}\
\\geometry{bottom=12mm}\
\\usepackage{fancyhdr}\
\\pagestyle{fancy}\
\\usepackage{lastpage}\
\\usepackage{indentfirst}\
\\usepackage[pdftex]{graphicx}\
		\\pagenumbering{arabic}\
		\\parindent=18pt\
		\\lhead{Faulty Network Router}\
		\\chead{}\
		\\rhead{}\
		\\lfoot{Thomas William Salmon - tws9}\
		\\cfoot{}\
		\\rfoot{\\thepage{} of \\pageref{LastPage}}\
		\\renewcommand{\\headrulewidth}{0.2pt}\
		\\renewcommand{\\footrulewidth}{0.15pt}\
		\\title{Faulty Network Router}\
		\\author{Thomas Salmon}\
		\\begin{document}\
\\thispagestyle{fancy}' -e '$a\
\\end{document}'  $1.tex   > /tmp/$1.tex

pdflatex /tmp/$1.tex
pdflatex /tmp/$1.tex
