/*
 * A short program, to run in user space, that communicates with the
 * ip_faulty_queue module of the modified kernel
*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "ipt_kernel_headers.h"
#include <linux/netfilter_ipv4/ip_tables.h>

/* define IP as same as in /etc/protocols */
#define IP	0

struct freq_struct {
	int freq;
	int reorder_freq;
	int reorder_delay;
	int reorder_block;
};

int main (int argc, char **argv){
	int fd;
	int freq, reorder_freq, reorder_delay, reorder_block;
	struct freq_struct fs;

	if (argc < 5){
		printf("Usage: fault_control <freq> <reorder frequency> <reorder delay> <reorder block>\n");
		printf("(Where freq is every n packet that is dropped)\n");
		printf("(Where reorder freq is which packet to place out of order)\n");
		printf("(Where reorder delay is by how many the packet is delayed)\n");
		printf("(Where reorder block is the size of block to be taken out of order\n");
		return -1;
	}

	fd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);

	freq = atoi(argv[1]);
	reorder_freq = atoi(argv[2]);
	reorder_delay = atoi(argv[3]);
	reorder_block = atoi(argv[4]);
	fs.freq = freq;
	fs.reorder_freq = reorder_freq;
	fs.reorder_delay = reorder_delay;
	fs.reorder_block = reorder_block;

	freq = setsockopt(fd, IP, IPT_BASE_CTL+2, &fs, sizeof(fs));
	printf("setsockopt returned %d\n", freq);
	printf("Error: %d\n", errno);
	return freq;
}
