#!/bin/bash

################################################################################
#
#		REQUIRES ROOT PRIVALEDGES
#
################################################################################

# Script to blast IP packets from one system to another

# USAGE:
#	ip_blast.sh <count> <min> <max> <source IP> <destination IP>
#
#Author: Thomas Salmon tom@slashtom.org

#
# When run, it <count> number of packets for each size value between <min> and
#<max>.
# Packets are addressed from <source IP> to <destination IP>

let PORT=9; 	# destination port to send traffic to
export IPGEN="ipgen/ipgen"; 	# IP packet generator program

if [ $# -ne 5 ]
then
	echo "Usage: ip_blast.sh <count> <min> <max> <source IP> <destination IP>";
	exit;
fi

# check root is running us
if [ "$USER" != "root" ]
then
	echo "You are not root, you do not have the authority!";
	exit;
fi


I=$2
while(test $I -le $3)
do
	${IPGEN} --tcp=$PORT -s $I -c $1 $4 $5;
	${IPGEN} --udp=$PORT -s $I -c $1 $4 $5;
	${IPGEN} --ip=2 -s $I -c $1 $4 $5; # igmp packets
	${IPGEN} --ping -s $I -c $1 $4 $5;
	let I=$I+1;
	sleep 2;
done

